#include <stdlib.h>
#include <string.h>
#include "cdbslib.h"

//====================================================================
// FILESYSTEM LIBRARY
//   Name: lastfile
//====================================================================

#define  MAXMATCH	100

/* LASTFILE -- Return the last file in alphabetical order matching a pattern
 *
 * i: pattern	wildcard pattern to be matched
 * o: fname	last file name matched
 * i: maxch	max file name length
 */

void lastfile (const char *pattern, char *fname, int maxch)
{
    int		ilist, jlist, nlist;
    char	*list[MAXMATCH];

    /* Expand filename pattern */

    nlist = 0;
    wild_expand (pattern, MAXMATCH, &nlist, list);

    /* Search for last match in alphabetical order */ 

    jlist = 0;
    for (ilist = 1; ilist < nlist; ilist ++) {
	if (strcmp (list[ilist], list[jlist]) > 0)
	    jlist = ilist;
    }

    safecopy (fname, list[jlist], maxch);
    for (ilist = 0; ilist < nlist; ilist ++) {
	free (list[ilist]); list[ilist]=NULL;
    }

}
